//=============================================================================
//
// file :        CS410LightController.h
//
// description : Include for the CS410LightController class.
//
// project :	
//
// $Author:  $
//
// $Revision:  $
//
// $Log:  $
//
// copyleft :    European Synchrotron Radiation Facility
//               BP 220, Grenoble 38043
//               FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================
#ifndef _CS410LIGHTCONTROLLER_H
#define _CS410LIGHTCONTROLLER_H

#include <tango.h>
#include "TangoDeviceConnection.h"

//using namespace Tango;

/**
 * @author	$Author:  $
 * @version	$Revision:  $
 */

 //	Add your own constants definitions here.
 //-----------------------------------------------


namespace CS410LightController_ns
{

/**
 * Class Description:
 * 
 */

/*
 *	Device States Description:
*  Tango::ON :
*  Tango::FAULT :
 */


class CS410LightController: public Tango::Device_4Impl
{
public :
	//	Add your own data members here
	//-----------------------------------------


	//	Here is the Start of the automatic code generation part
	//-------------------------------------------------------------	
/**
 *	@name attributes
 *	Attributs member data.
 */
//@{
		Tango::DevLong	*attr_Channel0Power_read;
		Tango::DevLong	*attr_Channel1Power_read;
//@}

/**
 *	@name Device properties
 *	Device properties member data.
 */
//@{
/**
 *	
 */
	string	serialDeviceConnectionString;
/**
 *	
 */
	Tango::DevLong	defaultChannel0Power;
/**
 *	
 */
	Tango::DevLong	defaultChannel1Power;
//@}

/**@name Constructors
 * Miscellaneous constructors */
//@{
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	CS410LightController(Tango::DeviceClass *cl,string &s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device Name
 */
	CS410LightController(Tango::DeviceClass *cl,const char *s);
/**
 * Constructs a newly allocated Command object.
 *
 *	@param cl	Class.
 *	@param s 	Device name
 *	@param d	Device description.
 */
	CS410LightController(Tango::DeviceClass *cl,const char *s,const char *d);
//@}

/**@name Destructor
 * Only one desctructor is defined for this class */
//@{
/**
 * The object desctructor.
 */	
	~CS410LightController() {delete_device();};
/**
 *	will be called at device destruction or at init command.
 */
	void delete_device();
//@}

	
/**@name Miscellaneous methods */
//@{
/**
 *	Initialize the device
 */
	virtual void init_device();
/**
 *	Always executed method befor execution command method.
 */
	virtual void always_executed_hook();

//@}

/**
 * @name CS410LightController methods prototypes
 */

//@{
/**
 *	Hardware acquisition for attributes.
 */
	virtual void read_attr_hardware(vector<long> &attr_list);
/**
 *	Extract real attribute values for Channel0Power acquisition result.
 */
	virtual void read_Channel0Power(Tango::Attribute &attr);
/**
 *	Extract real attribute values for Channel1Power acquisition result.
 */
	virtual void read_Channel1Power(Tango::Attribute &attr);
/**
 *	Read/Write allowed for Channel0Power attribute.
 */
	virtual bool is_Channel0Power_allowed(Tango::AttReqType type);
/**
 *	Read/Write allowed for Channel1Power attribute.
 */
	virtual bool is_Channel1Power_allowed(Tango::AttReqType type);
/**
 *	Execution allowed for SetChannel0Power command.
 */
	virtual bool is_SetChannel0Power_allowed(const CORBA::Any &any);
/**
 *	Execution allowed for SetChannel1Power command.
 */
	virtual bool is_SetChannel1Power_allowed(const CORBA::Any &any);
/**
 * 
 *	@param	argin	
 *	@exception DevFailed
 */
	void	set_channel0_power(Tango::DevLong);
/**
 * 
 *	@param	argin	
 *	@exception DevFailed
 */
	void	set_channel1_power(Tango::DevLong);

/**
 *	Read the device properties from database
 */
	 void get_device_property();
//@}

	//	Here is the end of the automatic code generation part
	//-------------------------------------------------------------	



protected :	
	//	Add your own data members here
	//-----------------------------------------
	
	TangoDeviceConnection *serial_device;
	Tango::DevLong channel0Power;
	Tango::DevLong channel1Power;
	
	Tango::DeviceProxy *get_serial_device() throw (Tango::DevFailed);
	void set_power_for_channel(int channel, Tango::DevLong power) throw (Tango::DevFailed);
	void update_power_for_channel(int channel) throw (Tango::DevFailed);
	Tango::DevLong get_and_parse_light_controller_power_response() throw (Tango::DevFailed);
	void flush_read_buffer(Tango::DeviceProxy *dev) throw (Tango::DevFailed);
	void write_string(Tango::DeviceProxy *dev, const std::string & str) throw (Tango::DevFailed);
	string read_line(Tango::DeviceProxy *dev) throw (Tango::DevFailed);
	
	static const char * COMMAND_OPTION_RESET;
	static const char * COMMAND_SET_CHANNEL_POWER;
	static const char * COMMAND_GET_CHANNEL_POWER;
	
	static const int CHANNEL_POWER_REPLY_LEN = 8;
	static const int RESET_REPLY_LEN = 4;
	
	static const Tango::DevLong CHANNEL_POWER_MIN = 0;
	static const Tango::DevLong CHANNEL_POWER_MAX = 1000;
};

}	// namespace_ns

#endif	// _CS410LIGHTCONTROLLER_H
