//=============================================================================
//
// file :         CS410LightControllerClass.h
//
// description :  Include for the CS410LightControllerClass root class.
//                This class is represents the singleton class for
//                the CS410LightController device class.
//                It contains all properties and methods which the 
//                CS410LightController requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author:  $
//
// $Revision:  $
//
// $Log:  $
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _CS410LIGHTCONTROLLERCLASS_H
#define _CS410LIGHTCONTROLLERCLASS_H

#include <tango.h>
#include <CS410LightController.h>


namespace CS410LightController_ns
{//=====================================
//	Define classes for attributes
//=====================================
class Channel1PowerAttrib: public Tango::Attr
{
public:
	Channel1PowerAttrib():Attr("Channel1Power", Tango::DEV_LONG, Tango::READ) {};
	~Channel1PowerAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<CS410LightController *>(dev))->read_Channel1Power(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<CS410LightController *>(dev))->is_Channel1Power_allowed(ty);}
};

class Channel0PowerAttrib: public Tango::Attr
{
public:
	Channel0PowerAttrib():Attr("Channel0Power", Tango::DEV_LONG, Tango::READ) {};
	~Channel0PowerAttrib() {};
	
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
	{(static_cast<CS410LightController *>(dev))->read_Channel0Power(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
	{return (static_cast<CS410LightController *>(dev))->is_Channel0Power_allowed(ty);}
};

//=========================================
//	Define classes for commands
//=========================================
class SetChannel1PowerCmd : public Tango::Command
{
public:
	SetChannel1PowerCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SetChannel1PowerCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SetChannel1PowerCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CS410LightController *>(dev))->is_SetChannel1Power_allowed(any);}
};



class SetChannel0PowerCmd : public Tango::Command
{
public:
	SetChannel0PowerCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SetChannel0PowerCmd(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SetChannel0PowerCmd() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CS410LightController *>(dev))->is_SetChannel0Power_allowed(any);}
};



//
// The CS410LightControllerClass singleton definition
//

class
#ifdef WIN32
	__declspec(dllexport)
#endif
	CS410LightControllerClass : public Tango::DeviceClass
{
public:
//	properties member data

//	add your own data members here
//------------------------------------

public:
	Tango::DbData	cl_prop;
	Tango::DbData	cl_def_prop;
	Tango::DbData	dev_def_prop;

//	Method prototypes
	static CS410LightControllerClass *init(const char *);
	static CS410LightControllerClass *instance();
	~CS410LightControllerClass();
	Tango::DbDatum	get_class_property(string &);
	Tango::DbDatum	get_default_device_property(string &);
	Tango::DbDatum	get_default_class_property(string &);
	
protected:
	CS410LightControllerClass(string &);
	static CS410LightControllerClass *_instance;
	void command_factory();
	void get_class_property();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();
	void set_default_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace CS410LightController_ns

#endif // _CS410LIGHTCONTROLLERCLASS_H
