#ifndef TANGODEVICECONNECTION_H_
#define TANGODEVICECONNECTION_H_

#include <string>
#include <tango.h>

class TangoDeviceConnection
{
public:
	TangoDeviceConnection(const std::string & _connect_string);
	virtual ~TangoDeviceConnection();
	
	virtual Tango::DeviceProxy *get() throw (Tango::DevFailed);
	virtual bool is_connected() const;
	
	virtual void disconnect();
	
private:
	std::string connect_string;
	Tango::DeviceProxy *device;
};

#endif /*TANGODEVICECONNECTION_H_*/
